## nlopt 2.6.1

=== CMakeLists.txt ===
#==============================================================================
# NLOPT CMake file
#
# NLopt is a free/open-source library for nonlinear optimization, providing
# a common interface for a number of different free optimization routines
# available online as well as original implementations of various other
# algorithms
# WEBSITE: http://ab-initio.mit.edu/wiki/index.php/NLopt
# AUTHOR: Steven G. Johnson
#
# This CMakeLists.txt file was created to compile NLOPT with the CMAKE utility.
# Benoit Scherrer, 2010 CRL, Harvard Medical School
# Copyright (c) 2008-2009 Children's Hospital Boston
#==============================================================================
cmake_minimum_required (VERSION 2.8.11)

if (NOT DEFINED CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project (nlopt)

#==============================================================================
# version
set (NLOPT_MAJOR_VERSION "2")
set (NLOPT_MINOR_VERSION "6")
set (NLOPT_BUGFIX_VERSION "1")
set (NLOPT_VERSION_STRING ${NLOPT_MAJOR_VERSION}.${NLOPT_MINOR_VERSION}.${NLOPT_BUGFIX_VERSION})
message (STATUS "NLopt version ${NLOPT_VERSION_STRING}")

# This is the ABI version number, which differes from the API version above
# (it indicates ABI compatibility), but they are typically incremented together.
set(SO_MAJOR 0)
set(SO_MINOR 10)
set(SO_PATCH 0)
#==============================================================================

list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

option (NLOPT_CXX "enable cxx routines" ON)
option (NLOPT_FORTRAN "enable fortran tests" OFF)
option (BUILD_SHARED_LIBS "Build NLopt as a shared library" ON)
option (NLOPT_PYTHON "build python bindings" ON)
option (NLOPT_OCTAVE "build octave bindings" ON)
option (NLOPT_MATLAB "build matlab bindings" ON)
option (NLOPT_GUILE "build guile bindings" ON)
option (NLOPT_SWIG "use SWIG to build bindings" ON)

if (CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  option (NLOPT_TESTS "build unit tests" ON)
else ()
  option (NLOPT_TESTS "build unit tests" OFF)
endif ()

if (NLOPT_FORTRAN)
  enable_language (Fortran)
endif ()

include (GNUInstallDirs)

# Offer the user the choice of overriding the installation directories
set (INSTALL_LIB_DIR     ${CMAKE_INSTALL_LIBDIR}        CACHE PATH "Installation directory for libraries")
set (INSTALL_BIN_DIR     ${CMAKE_INSTALL_BINDIR}        CACHE PATH "Installation directory for executables")
set (INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR}    CACHE PATH "Installation directory for header files")
set (INSTALL_DATA_DIR    ${CMAKE_INSTALL_DATADIR}/nlopt CACHE PATH "Installation directory for data files")
set (INSTALL_MAN_DIR     ${CMAKE_INSTALL_MANDIR}        CACHE PATH "Installation directory for man documentation")
set (INSTALL_CMAKE_DIR   ${INSTALL_LIB_DIR}/cmake/nlopt CACHE PATH "Installation directory for cmake config files")

# Make relative paths absolute (needed later on)
foreach (p LIB BIN INCLUDE DATA CMAKE)
  set (var INSTALL_${p}_DIR)
  set (RELATIVE_INSTALL_${p}_DIR ${INSTALL_${p}_DIR})
  if (NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif ()
endforeach ()


set (CMAKE_INSTALL_RPATH ${INSTALL_LIB_DIR})
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
if(POLICY CMP0042)
  # Set MACOSX_RPATH to ON
  cmake_policy(SET CMP0042 NEW)
endif()
if (POLICY CMP0086)
  # UseSWIG honors SWIG_MODULE_NAME via -module flag
  cmake_policy(SET CMP0086 NEW)
endif ()

include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckTypeSize)
include (CheckCCompilerFlag)
include (CheckCXXSymbolExists)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

#==============================================================================
# COMPILATION CHECKINGS and CONFIGURATION GENERATION
#==============================================================================
check_include_file (dlfcn.h HAVE_DLFCN_H)
check_include_file (getopt.h HAVE_GETOPT_H)
check_include_file (unistd.h HAVE_UNISTD_H)
check_include_file (string.h HAVE_STRING_H)
check_include_file (strings.h HAVE_STRINGS_H)
check_include_file (inttypes.h HAVE_INTTYPES_H)
check_include_file (memory.h HAVE_MEMORY_H)
check_include_file (stdlib.h HAVE_STDLIB_H)
check_include_file (stdint.h HAVE_STDINT_H)
check_include_file (time.h HAVE_TIME_H)
check_include_file (sys/types.h HAVE_SYS_TYPES_H)
check_include_file (sys/stat.h HAVE_SYS_STAT_H)
check_include_file (sys/time.h HAVE_SYS_TIME_H)
if (HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set (TIME_WITH_SYS_TIME TRUE)
endif ()
check_function_exists (getpid HAVE_GETPID)
check_function_exists (syscall HAVE_GETTID_SYSCALL)
check_function_exists (isinf HAVE_ISINF)
check_function_exists (isnan HAVE_ISNAN)
check_function_exists (gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists (qsort_r HAVE_QSORT_R)
check_function_exists (time HAVE_TIME)
check_function_exists (copysign HAVE_COPYSIGN)
check_type_size ("uint32_t" SIZEOF_UINT32_T)
set (HAVE_UINT32_T ${SIZEOF_UINT32_T})
check_type_size ("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size ("unsigned long" SIZEOF_UNSIGNED_LONG)

check_library_exists ("m" sqrt "" HAVE_LIBM)
if (HAVE_LIBM)
  set (M_LIBRARY m)
endif()

if (NOT DEFINED HAVE_FPCLASSIFY)
  message(STATUS "Looking for fpclassify")
  file (WRITE ${PROJECT_BINARY_DIR}/fpclassify.c "#include <math.h>\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "int main(void) {\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "if (!fpclassify(3.14159)) fpclassify(2.7183);\n")
  file (APPEND ${PROJECT_BINARY_DIR}/fpclassify.c "  return 0; }\n")
  try_compile (HAVE_FPCLASSIFY
  ${PROJECT_BINARY_DIR}/build_fpclassify
  ${PROJECT_BINARY_DIR}/fpclassify.c
  CMAKE_FLAGS -DLINK_LIBRARIES=m)
  message(STATUS "Looking for fpclassify - ${HAVE_FPCLASSIFY}")
endif ()

option (WITH_THREADLOCAL "check thread local keyword" ON)
if (WITH_THREADLOCAL AND NOT DEFINED THREADLOCAL)
  foreach (_THREADLOCAL_KEY "__thread" "__declspec(thread)")
    unset (HAVE_THREAD_LOCAL_STORAGE CACHE)
    check_c_source_compiles("
    ${_THREADLOCAL_KEY} int tls;

    int main(void) {
        return 0;
    }" HAVE_THREAD_LOCAL_STORAGE)
    if (HAVE_THREAD_LOCAL_STORAGE)
      set (THREADLOCAL ${_THREADLOCAL_KEY} CACHE STRING "Thread local keyword")
    endif ()
  endforeach()
endif ()


if (NLOPT_CXX OR NLOPT_PYTHON OR NLOPT_GUILE OR NLOPT_OCTAVE)
  check_cxx_symbol_exists (__cplusplus ciso646 SYSTEM_HAS_CXX)
  if (SYSTEM_HAS_CXX)
    check_cxx_compiler_flag ("-std=c++11" SUPPORTS_STDCXX11)
    if (SUPPORTS_STDCXX11)
      set (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
      if (NLOPT_CXX)
        set (NLOPT_CXX11 ON)
      endif ()
    endif ()
  else()
    message (FATAL_ERROR "The compiler doesn't support CXX.")
  endif ()
endif ()

#==============================================================================
# CREATE nlopt_config.h
#==============================================================================

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt_config.h IMMEDIATE)

# pkgconfig file
if (UNIX OR MINGW)
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/nlopt.pc.in ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc @ONLY)
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.pc DESTINATION ${RELATIVE_INSTALL_LIB_DIR}/pkgconfig)
endif ()

#==============================================================================
# nlopt LIBRARY TARGET (SHARED OR STATIC)
#==============================================================================

configure_file (src/api/nlopt.h ${PROJECT_BINARY_DIR}/src/api/nlopt.h COPYONLY)

set (NLOPT_HEADERS
  ${PROJECT_BINARY_DIR}/src/api/nlopt.h ${PROJECT_BINARY_DIR}/src/api/nlopt.hpp ${PROJECT_BINARY_DIR}/src/api/nlopt.f
)

set (NLOPT_SOURCES
  src/algs/direct/DIRect.c src/algs/direct/direct_wrap.c src/algs/direct/DIRserial.c src/algs/direct/DIRsubrout.c src/algs/direct/direct-internal.h src/algs/direct/direct.h
  src/algs/cdirect/cdirect.c src/algs/cdirect/hybrid.c src/algs/cdirect/cdirect.h
  src/algs/praxis/praxis.c src/algs/praxis/praxis.h
  src/algs/luksan/plis.c src/algs/luksan/plip.c src/algs/luksan/pnet.c src/algs/luksan/mssubs.c src/algs/luksan/pssubs.c src/algs/luksan/luksan.h
  src/algs/crs/crs.c src/algs/crs/crs.h
  src/algs/mlsl/mlsl.c src/algs/mlsl/mlsl.h
  src/algs/mma/mma.c src/algs/mma/mma.h src/algs/mma/ccsa_quadratic.c
  src/algs/cobyla/cobyla.c src/algs/cobyla/cobyla.h
  src/algs/newuoa/newuoa.c src/algs/newuoa/newuoa.h
  src/algs/neldermead/nldrmd.c src/algs/neldermead/neldermead.h src/algs/neldermead/sbplx.c
  src/algs/auglag/auglag.c src/algs/auglag/auglag.h
  src/algs/bobyqa/bobyqa.c src/algs/bobyqa/bobyqa.h
  src/algs/isres/isres.c src/algs/isres/isres.h
  src/algs/slsqp/slsqp.c src/algs/slsqp/slsqp.h
  src/algs/esch/esch.c src/algs/esch/esch.h
  src/api/general.c src/api/options.c src/api/optimize.c src/api/deprecated.c src/api/nlopt-internal.h src/api/nlopt.h src/api/f77api.c src/api/f77funcs.h src/api/f77funcs_.h src/api/nlopt.hpp src/api/nlopt-in.hpp
  src/util/mt19937ar.c src/util/sobolseq.c src/util/soboldata.h src/util/timer.c src/util/stop.c src/util/nlopt-util.h src/util/redblack.c src/util/redblack.h src/util/qsort_r.c src/util/rescale.c
)

if (NLOPT_CXX)
  list (APPEND NLOPT_SOURCES src/algs/stogo/global.cc src/algs/stogo/linalg.cc src/algs/stogo/local.cc src/algs/stogo/stogo.cc src/algs/stogo/tools.cc
        src/algs/stogo/global.h src/algs/stogo/linalg.h src/algs/stogo/local.h src/algs/stogo/stogo_config.h src/algs/stogo/stogo.h src/algs/stogo/tools.h)
endif ()
if (NLOPT_CXX11)
  list (APPEND NLOPT_SOURCES src/algs/ags/data_types.hpp src/algs/ags/evolvent.hpp src/algs/ags/evolvent.cc src/algs/ags/solver.hpp src/algs/ags/solver.cc
  src/algs/ags/local_optimizer.hpp src/algs/ags/local_optimizer.cc src/algs/ags/ags.h src/algs/ags/ags.cc)
endif ()

install (FILES ${NLOPT_HEADERS} DESTINATION ${RELATIVE_INSTALL_INCLUDE_DIR})

set (nlopt_lib nlopt)
add_library (${nlopt_lib} ${NLOPT_SOURCES})
target_link_libraries (${nlopt_lib} ${M_LIBRARY})

set_target_properties (${nlopt_lib} PROPERTIES SOVERSION ${SO_MAJOR})
set_target_properties (${nlopt_lib} PROPERTIES VERSION "${SO_MAJOR}.${SO_MINOR}.${SO_PATCH}")

#==============================================================================
# INCLUDE DIRECTORIES
#==============================================================================
target_include_directories (${nlopt_lib} PRIVATE
  ${PROJECT_BINARY_DIR}/src/api
  ${PROJECT_BINARY_DIR}
  src/algs/stogo
  src/algs/ags
  src/util
  src/algs/direct
  src/algs/cdirect
  src/algs/praxis
  src/algs/luksan
  src/algs/crs
  src/algs/mlsl
  src/algs/mma
  src/algs/cobyla
  src/algs/newuoa
  src/algs/neldermead
  src/algs/auglag
  src/algs/bobyqa
  src/algs/isres
  src/algs/slsqp
  src/algs/esch
  src/api)

get_target_property (NLOPT_PRIVATE_INCLUDE_DIRS ${nlopt_lib} INCLUDE_DIRECTORIES)
target_include_directories (${nlopt_lib} INTERFACE "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src/api>" "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")

if (BUILD_SHARED_LIBS)
  target_compile_definitions (${nlopt_lib} PUBLIC NLOPT_DLL)
  target_compile_definitions (${nlopt_lib} PRIVATE NLOPT_DLL_EXPORT)
endif ()

# pass -fPIC in case swig module is built with static library
if (NOT BUILD_SHARED_LIBS)
  check_c_compiler_flag (-fPIC HAS_FPIC)
  if (HAS_FPIC)
    set (CMAKE_C_FLAGS "-fPIC ${CMAKE_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "-fPIC ${CMAKE_CXX_FLAGS}")
  endif ()
endif ()

install ( TARGETS ${nlopt_lib}
          EXPORT  NLoptLibraryDepends
          RUNTIME DESTINATION ${RELATIVE_INSTALL_BIN_DIR}
          LIBRARY DESTINATION ${RELATIVE_INSTALL_LIB_DIR}
          ARCHIVE DESTINATION ${RELATIVE_INSTALL_LIB_DIR}
        )

if (MSVC AND BUILD_SHARED_LIBS AND NOT CMAKE_VERSION VERSION_LESS 3.1)
  install (FILES $<TARGET_PDB_FILE:${nlopt_lib}> DESTINATION ${RELATIVE_INSTALL_BIN_DIR} CONFIGURATIONS Debug RelWithDebInfo COMPONENT Debug)
endif ()

=== test/CMakeLists.txt ===
add_custom_target (tests)

# have to add timer.c and mt19937ar.c as symbols are declared extern
add_executable (testopt testfuncs.c testfuncs.h testopt.c
  ${PROJECT_SOURCE_DIR}/src/util/timer.c ${PROJECT_SOURCE_DIR}/src/util/mt19937ar.c ${PROJECT_SOURCE_DIR}/src/util/nlopt-getopt.c)
target_link_libraries (testopt ${nlopt_lib})
if (NLOPT_CXX)
  set_target_properties(testopt PROPERTIES LINKER_LANGUAGE CXX)
endif ()
target_include_directories (testopt PRIVATE ${NLOPT_PRIVATE_INCLUDE_DIRS})
add_dependencies (tests testopt)

foreach (algo_index RANGE 29)# 43
  foreach (obj_index RANGE 1)# 21
    set (enable_ TRUE)
    # cxx stogo
    if (NOT NLOPT_CXX)
      if (algo_index STREQUAL 8 OR algo_index STREQUAL 9)
        set (enable_ FALSE)
      endif ()
    endif ()
    # cxx11 ags
    if (NOT NLOPT_CXX11 AND algo_index STREQUAL 43)
      set (enable_ FALSE)
    endif ()
    # L-BFGS
    if (algo_index STREQUAL 10)
      set (enable_ FALSE)
    endif ()
    # LN_NEWUOA_BOUND timeouts on msvc
    if (algo_index STREQUAL 27)
      set (enable_ FALSE)
    endif ()
    if (enable_)
      add_test (NAME testopt_algo${algo_index}_obj${obj_index} COMMAND testopt -r 0 -a ${algo_index} -o ${obj_index})
      if (CMAKE_HOST_SYSTEM_NAME MATCHES Windows)
        set_tests_properties (testopt_algo${algo_index}_obj${obj_index} PROPERTIES ENVIRONMENT "PATH=${PROJECT_BINARY_DIR}\\${CMAKE_BUILD_TYPE};$ENV{PATH}")  # to load dll
      endif ()
    endif ()
  endforeach ()
endforeach ()

if (NUMPY_FOUND AND PYTHONLIBS_FOUND AND (SWIG_FOUND OR (EXISTS ${PROJECT_SOURCE_DIR}/src/swig/nlopt-python.cpp)))
  set (PYINSTALLCHECK_ENVIRONMENT "LD_LIBRARY_PATH=${PROJECT_BINARY_DIR}/src/swig"
                                  "PYTHONPATH=${PROJECT_BINARY_DIR}/src/swig"
    )
  add_test (NAME test_python COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_python.py)
  set_tests_properties (test_python PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
endif ()

if (OCTAVE_FOUND)
  add_test (NAME test_octave COMMAND ${OCTAVE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_octave.m ${PROJECT_SOURCE_DIR}/src/octave ${PROJECT_BINARY_DIR}/src/octave)
endif ()

if (GUILE_FOUND AND ((SWIG_FOUND AND SWIG_VERSION VERSION_GREATER 2.0.9) OR (EXISTS ${PROJECT_SOURCE_DIR}/src/swig/nlopt-guile.cpp)))
  set (GUILECHECK_ENVIRONMENT "LD_LIBRARY_PATH=${PROJECT_BINARY_DIR}/src/swig"
                              "GUILE_LOAD_PATH=${PROJECT_BINARY_DIR}/src/swig"
    )
  add_test (NAME test_guile COMMAND ${GUILE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/t_guile.scm)
  set_tests_properties (test_guile PROPERTIES ENVIRONMENT "${GUILECHECK_ENVIRONMENT}")
endif ()

if (NLOPT_FORTRAN)
  add_executable (t_fortran t_fortran.f90)
  target_link_libraries (t_fortran ${nlopt_lib})
  add_test (NAME test_fortran COMMAND t_fortran)
endif ()

=== src/api/CMakeLists.txt ===

# install man
if (UNIX)
  install (FILES nlopt.3 nlopt_minimize.3 nlopt_minimize_constrained.3 DESTINATION ${INSTALL_MAN_DIR}/man3)
endif ()

# generate nlopt.f from nlopt.h enums
if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/nlopt.f)
  file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/nlopt.f "")
  file (STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt.h NLOPT_H_LINES REGEX "    NLOPT_[A-Z0-9_]+")
  set (i 0)
  foreach (NLOPT_H_LINE ${NLOPT_H_LINES})
    if (NOT NLOPT_H_LINE MATCHES "NLOPT_NUM_")
      string (REGEX REPLACE ".*NLOPT_([A-Z0-9_]+).*" "\\1" ENUM_STRING ${NLOPT_H_LINE})
      string (REGEX REPLACE ".*NLOPT_[A-Z0-9_]+ = (-?[0-9]+).*" "\\1" ENUM_VAL ${NLOPT_H_LINE})
      if (ENUM_VAL MATCHES "^-?[0-9]+$")
        set (i ${ENUM_VAL})
      endif ()
      set (ENUM_LINE "      integer NLOPT_${ENUM_STRING}\n      parameter (NLOPT_${ENUM_STRING}=${i})\n")
      file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.f "${ENUM_LINE}")

      # https://public.kitware.com/Bug/print_bug_page.php?bug_id=8996
      if (i MATCHES "^-")
        math (EXPR i "1 ${i}")
      else ()
        math (EXPR i "${i} + 1")
      endif ()
    endif ()
  endforeach ()
endif ()

# generate nlopt.hpp from nlopt-in.hpp
if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp)
  file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "")
  file (STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt-in.hpp NLOPT_HPP_LINES)
  foreach (NLOPT_HPP_LINE ${NLOPT_HPP_LINES})
    list(LENGTH NLOPT_HPP_LINE line_len)
    # handling trailing backlashes in "file (STRINGS" is a little tricky
    if (line_len VERSION_LESS 8)
      file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "${NLOPT_HPP_LINE}\n")
    else ()
      set (prev_inst FALSE)
      foreach(NLOPT_HPP_SUBLINE ${NLOPT_HPP_LINE})
        # test is we need to add the eaten semicolon
        if (NLOPT_HPP_SUBLINE MATCHES "\\)$" OR NLOPT_HPP_SUBLINE MATCHES "return")
          set (new_inst TRUE)
        else ()
          set (new_inst FALSE)
        endif ()
        if (NOT prev_inst)
          file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "${NLOPT_HPP_SUBLINE}")
          if (new_inst)
            file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp ";")
          endif ()
          list (FIND NLOPT_HPP_LINE "${NLOPT_HPP_SUBLINE}" index)
          math (EXPR index "${index} + 1")
          list (LENGTH NLOPT_HPP_LINE total)
          if (NOT index STREQUAL total)
            file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp " \\")
          endif ()
          file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "\n")
        endif ()
        set (prev_inst ${new_inst})
      endforeach ()
    endif ()
    if (NLOPT_HPP_LINE MATCHES "GEN_ENUMS_HERE")
      file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "  enum algorithm {\n")
      file (STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt.h NLOPT_H_LINES REGEX "    NLOPT_[A-Z0-9_]+")
      foreach (NLOPT_H_LINE ${NLOPT_H_LINES})
        string (REGEX REPLACE "NLOPT_" "" ENUM_LINE ${NLOPT_H_LINE})
        file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "${ENUM_LINE}\n")
        if (NLOPT_H_LINE MATCHES "NLOPT_NUM_ALGORITHMS")
          file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "  };\n  enum result {\n")
        elseif (NLOPT_H_LINE MATCHES "NLOPT_MAXTIME_REACHED")
          file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt.hpp "  };\n")
        endif ()
      endforeach ()
    endif ()
  endforeach ()
endif ()

=== src/octave/CMakeLists.txt ===
set (MFILES NLOPT_GN_DIRECT.m NLOPT_GN_DIRECT_L.m NLOPT_GN_DIRECT_L_RAND.m NLOPT_GN_DIRECT_NOSCAL.m NLOPT_GN_DIRECT_L_NOSCAL.m NLOPT_GN_DIRECT_L_RAND_NOSCAL.m NLOPT_GN_ORIG_DIRECT.m NLOPT_GN_ORIG_DIRECT_L.m NLOPT_GD_STOGO.m NLOPT_GD_STOGO_RAND.m NLOPT_LD_LBFGS_NOCEDAL.m NLOPT_LD_LBFGS.m NLOPT_LN_PRAXIS.m NLOPT_LD_VAR1.m NLOPT_LD_VAR2.m NLOPT_LD_TNEWTON.m NLOPT_LD_TNEWTON_RESTART.m NLOPT_LD_TNEWTON_PRECOND.m NLOPT_LD_TNEWTON_PRECOND_RESTART.m NLOPT_GN_CRS2_LM.m NLOPT_GN_MLSL.m NLOPT_GD_MLSL.m NLOPT_GN_MLSL_LDS.m NLOPT_GD_MLSL_LDS.m NLOPT_LD_MMA.m NLOPT_LN_COBYLA.m NLOPT_LN_NEWUOA.m NLOPT_LN_NEWUOA_BOUND.m NLOPT_LN_NELDERMEAD.m NLOPT_LN_SBPLX.m NLOPT_LN_AUGLAG.m NLOPT_LD_AUGLAG.m NLOPT_LN_AUGLAG_EQ.m NLOPT_LD_AUGLAG_EQ.m NLOPT_LN_BOBYQA.m NLOPT_GN_ISRES.m NLOPT_AUGLAG.m NLOPT_AUGLAG_EQ.m NLOPT_G_MLSL.m NLOPT_G_MLSL_LDS.m NLOPT_LD_SLSQP.m NLOPT_LD_CCSAQ.m NLOPT_GN_ESCH.m)
set (M_DATA ${MFILES} nlopt_minimize.m nlopt_minimize_constrained.m)


if (Matlab_FOUND AND Matlab_MX_LIBRARY)
  cmake_minimum_required (VERSION 3.3) # for the matlab_add_mex macro

  matlab_add_mex (NAME nlopt_optimize-mex SRC nlopt_optimize-mex.c OUTPUT_NAME nlopt_optimize LINK_TO ${nlopt_lib})

  if (NOT DEFINED INSTALL_MEX_DIR)
    set (INSTALL_MEX_DIR ${INSTALL_LIB_DIR}/matlab)
  endif ()
  install (TARGETS nlopt_optimize-mex DESTINATION ${INSTALL_MEX_DIR})

  if (NOT DEFINED INSTALL_M_DIR)
    set (INSTALL_M_DIR ${INSTALL_MEX_DIR})
  endif ()
  install (FILES ${M_DATA} DESTINATION ${INSTALL_M_DIR})
endif ()



if (OCTAVE_FOUND)
  file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/nlopt_optimize_usage.h "#define NLOPT_OPTIMIZE_USAGE \\\n")
  file (STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt_optimize.m INPUT_LINES)
  foreach (INPUT_LINE ${INPUT_LINES})
    string (REGEX REPLACE "^% " "" INPUT_LINE ${INPUT_LINE})
    string (REGEX REPLACE "^%" "" INPUT_LINE ${INPUT_LINE})
    foreach (repl_expr "tolerance" "help NLOPT_LN_SBPLX" "population")
      string (REGEX REPLACE "\"${repl_expr}\"" "${repl_expr}" INPUT_LINE "${INPUT_LINE}")
    endforeach ()
    file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt_optimize_usage.h "\"${INPUT_LINE}\\n\" \\\n")
  endforeach ()
  file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt_optimize_usage.h "\n")

  include_directories (${OCTAVE_INCLUDE_DIRS})
  include_directories (${CMAKE_CURRENT_BINARY_DIR})
  octave_add_oct (nlopt_optimize SOURCES nlopt_optimize-oct.cc ${CMAKE_CURRENT_BINARY_DIR}/nlopt_optimize_usage.h LINK_LIBRARIES ${nlopt_lib})

  if (NOT DEFINED INSTALL_OCT_DIR)
    file (RELATIVE_PATH INSTALL_OCT_DIR ${OCTAVE_ROOT_DIR} ${OCTAVE_OCT_SITE_DIR})
  endif ()
  install (TARGETS nlopt_optimize DESTINATION ${INSTALL_OCT_DIR})

  if (NOT DEFINED INSTALL_M_DIR)
    file (RELATIVE_PATH INSTALL_M_DIR ${OCTAVE_ROOT_DIR} ${OCTAVE_M_SITE_DIR})
  endif ()

  install (FILES ${M_DATA} DESTINATION ${INSTALL_M_DIR})
endif ()

=== src/swig/CMakeLists.txt ===

if (POLICY CMP0078)
  cmake_policy(SET CMP0078 NEW)
endif ()
include (UseSWIG)
include (TargetLinkLibrariesWithDynamicLookup)

if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/nlopt-enum-renames.i)
  file (WRITE ${CMAKE_CURRENT_BINARY_DIR}/nlopt-enum-renames.i "// AUTOMATICALLY GENERATED -- DO NOT EDIT\n")
  file (STRINGS ${PROJECT_SOURCE_DIR}/src/api/nlopt.h NLOPT_H_LINES REGEX "    NLOPT_[A-Z0-9_]+")
  foreach (NLOPT_H_LINE ${NLOPT_H_LINES})
    string (REGEX REPLACE ".*NLOPT_([A-Z0-9_]+).*" "%rename(NLOPT_\\1) nlopt::\\1;\n" ENUM_LINE ${NLOPT_H_LINE})
    file (APPEND ${CMAKE_CURRENT_BINARY_DIR}/nlopt-enum-renames.i "${ENUM_LINE}")
  endforeach ()
endif ()

include_directories (${NLOPT_PRIVATE_INCLUDE_DIRS})
set_source_files_properties (nlopt.i PROPERTIES CPLUSPLUS ON)

if (NUMPY_FOUND AND PYTHONLIBS_FOUND)

  set (SWIG_MODULE_nlopt_python_EXTRA_DEPS nlopt-python.i numpy.i)

  # swig_add_module is deprecated
  if (CMAKE_VERSION VERSION_LESS 3.8)
    swig_add_module (nlopt_python python nlopt.i)
  else ()
    swig_add_library (nlopt_python LANGUAGE python SOURCES nlopt.i)
  endif ()

  # UseSWIG generates now standard target names
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set (nlopt_python ${SWIG_MODULE_nlopt_python_REAL_NAME})
  else ()
    set (nlopt_python "nlopt_python")
  endif ()

  target_include_directories (${nlopt_python} PUBLIC ${PYTHON_INCLUDE_DIRS})
  target_include_directories (${nlopt_python} PUBLIC ${NUMPY_INCLUDE_DIRS})

  swig_link_libraries (nlopt_python ${nlopt_lib})
  target_link_libraries_with_dynamic_lookup (${nlopt_python} ${PYTHON_LIBRARIES})

  set_target_properties (${nlopt_python} PROPERTIES OUTPUT_NAME nlopt)
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set_target_properties (${nlopt_python} PROPERTIES PREFIX "_")
  endif ()

  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.py DESTINATION ${INSTALL_PYTHON_DIR})
  install (TARGETS ${nlopt_python} LIBRARY DESTINATION ${INSTALL_PYTHON_DIR})
endif ()


# guile bindings with gcc only ok with swig >= 2.0.10
if (GUILE_FOUND AND (SWIG_VERSION VERSION_GREATER 2.0.9))

  set_source_files_properties (nlopt.i PROPERTIES SWIG_FLAGS "-scmstub")
  set (SWIG_MODULE_nlopt_guile_EXTRA_DEPS nlopt-guile.i)

  # swig_add_module is deprecated
  if (CMAKE_VERSION VERSION_LESS 3.8)
    swig_add_module (nlopt_guile guile nlopt.i)
  else ()
    swig_add_library (nlopt_guile LANGUAGE guile SOURCES nlopt.i)
  endif ()

  # UseSWIG generates now standard target names
  if (CMAKE_VERSION VERSION_LESS 3.13)
    set (nlopt_guile ${SWIG_MODULE_nlopt_guile_REAL_NAME})
  else ()
    set (nlopt_guile "nlopt_guile")
  endif ()

  target_include_directories (${nlopt_guile} PUBLIC ${GUILE_INCLUDE_DIRS})

  swig_link_libraries (nlopt_guile ${nlopt_lib})
  target_link_libraries_with_dynamic_lookup (${nlopt_guile} ${GUILE_LIBRARIES})

  file (RELATIVE_PATH _REL_GUILE_SITE_PATH ${GUILE_ROOT_DIR} ${GUILE_SITE_DIR})
  set (GUILE_SITE_PATH ${_REL_GUILE_SITE_PATH})
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/nlopt.scm DESTINATION ${GUILE_SITE_PATH})

  file (RELATIVE_PATH _REL_GUILE_EXTENSION_PATH ${GUILE_ROOT_DIR} ${GUILE_EXTENSION_DIR})
  set (GUILE_EXTENSION_PATH ${_REL_GUILE_EXTENSION_PATH})
  install (TARGETS ${nlopt_guile} LIBRARY DESTINATION ${GUILE_EXTENSION_PATH})
endif ()

=== debian/changelog ===
nlopt (2.6.1-8ubuntu2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:38:16 +0100

nlopt (2.6.1-8ubuntu1) focal; urgency=medium

  * Fix creating alternative python3 bindings.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 13 Feb 2020 00:24:04 +0000

nlopt (2.6.1-8) unstable; urgency=medium

  * Team upload.
  * fix-octave-install-path.patch: new patch, fixes the installation path of
    Octave files, so that the package needs not to be rebuilt at every new
    upstream version of Octave.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 05 Feb 2020 15:15:38 +0100

nlopt (2.6.1-7) unstable; urgency=medium

  * Team upload.
  * Build-Depends: dh-python. Closes: #945128.
  * Build python extension for all available python3 versions.
    Closes: #943634.

 -- Drew Parsons <dparsons@debian.org>  Sat, 30 Nov 2019 16:50:25 +0800

nlopt (2.6.1-6) unstable; urgency=medium

  * Team upload.
  * d/control: Bump dependency on dh-octave to >= 0.7.1

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 14 Nov 2019 12:01:24 -0300

nlopt (2.6.1-5) unstable; urgency=medium

  * Team upload.
  * fix installation of nlopt.hpp in libnlopt-cxx-dev

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Oct 2019 16:53:59 +0800

nlopt (2.6.1-4) unstable; urgency=medium

  * Team upload.
  * debian/tests Depends: python3-numpy
  * Standards-Version: 4.4.1
  * install cmake scripts in libnlopt-dev. Closes: #862390.
     - cmake/nlopt configures C-only build (matching pkg-config nlopt)
     - cmake/nlopt_cxx configures default build (with C++ support,
       matching pkg-config nlopt_cxx)

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Oct 2019 16:40:24 +0800

nlopt (2.6.1-3) unstable; urgency=medium

  * Team upload.
  * run dh_auto_install for binary-arch builds only.

 -- Drew Parsons <dparsons@debian.org>  Tue, 08 Oct 2019 00:15:40 +0800

nlopt (2.6.1-2) unstable; urgency=medium

  * Team upload.
  * No change upload, needed for testing migration (because arch:all
    packages of previous upload were not built on buildds, since they went
    through the NEW queue)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 07 Oct 2019 14:24:49 +0200

nlopt (2.6.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies all debian patches
    - update debian/libnlopt0.symbols
  * drop Files-Excluded in debian/copyright (pdf files no longer
    shipped in tarball) and refresh debian/watch to uscan v4
  * Build using cmake
    - debian patch set_cxx_soname.patch sets library name to
      libnlopt_cxx.so for the default build with C++ algorithms
  * Build-Depends: swig
  * provide nlopt-doc package with HTML documentation
    - debian patch docs_skip_mdx_math.patch skips mdx_math in docs.
      It is provided by python-markdown-math which is not packaged yet.
      Needed to render inline TeX maths e.g. $lb_i = ub_i$, so we'll
      manage without that for now.
    - Depends: libjs-highlight.js, libjs-jquery, libjs-mathjax
  * libnlopt-cxx-dev installs nlopt_cxx.pc pkgconfig file for C++ build
  * add debian/tests (autopkgtest)

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Sep 2019 11:58:45 +0800

nlopt (2.4.2+dfsg-10) unstable; urgency=medium

  * Team upload.
  * source upload to migrate python3-nlopt to testing

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Sep 2019 13:24:51 +0800

nlopt (2.4.2+dfsg-9) unstable; urgency=medium

  * Team upload.

  [ Sergey B Kirpichev ]
  * Removed .gitignore (conflict with upstream one)
  * Bump up Standards-Version (to 4.3.0)
  * Remove Testsuite header (no tests yet)
  * Provide python3-nlopt package
  * Adapt watch file to track Github
  * Switch to guile-2.2 (Closes: #885224)

  [ Drew Parsons ]
  * Standards-Version: 4.4.0
  * debhelper compatibility level 12 (debhelper-compat (= 12))
  * drop python-nlopt (Python2 is deprecated). Closes: #937147.

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Sep 2019 03:51:55 +0800

=== debian/control ===
Source: nlopt
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 12),
               chrpath,
               cmake,
               dh-octave (>= 0.7.1),
               dh-python,
               python3-all-dev,
               python3-numpy,
               guile-2.2,
               guile-2.2-dev,
               swig
Build-Depends-Indep: mkdocs,
                     libjs-highlight.js,
                     libjs-jquery,
                     libjs-mathjax
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/science-team/nlopt
Vcs-Git: https://salsa.debian.org/science-team/nlopt.git
Homepage: http://ab-initio.mit.edu/wiki/index.php/NLopt

Package: libnlopt0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the shared libraries required to run programs
 compiled with NLopt. To compile your own programs you also need to
 install libnlopt-dev.

Package: libnlopt-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnlopt0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: nonlinear optimization library -- development package
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the header files, static libraries and symbolic
 links that developers using NLopt library will need.

Package: libnlopt-cxx0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library (C++ interface)
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the shared libraries required to run programs
 compiled with NLopt in C++. To compile your own programs you also need to
 install libnlopt-cxx-dev.

Package: libnlopt-cxx-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libnlopt-dev (= ${binary:Version}),
         libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: nonlinear optimization library -- development package for C++
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the header files, static libraries and symbolic
 links that developers using NLopt library with C++ will need.

Package: python3-nlopt
Architecture: any
Section: python
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Provides: ${python3:Provides}
Description: nonlinear optimization library -- Python 3 bindings
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the Python 3 bindings.

Package: octave-nlopt
Architecture: any
Multi-Arch: same
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${octave:Depends}
Description: nonlinear optimization library -- GNU Octave package
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the module for the GNU Octave.

Package: libnlopt-guile0
Architecture: any
Multi-Arch: same
Section: libs
Depends: libnlopt-cxx0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         guile-2.2
Pre-Depends: ${misc:Pre-Depends}
Description: nonlinear optimization library -- Guile bindings
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package contains the bindings for GNU Guile.

Package: nlopt-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-highlight.js,
         libjs-jquery,
         libjs-mathjax
Description: nonlinear optimization library (documentation)
 NLopt is a free/open-source library for nonlinear optimization, providing
 a common interface for a number of different free optimization routines
 available online as well as original implementations of various other
 algorithms. Its features include:
 .
    * Callable from C, C++, Fortran, GNU Octave, Python, GNU Guile, GNU R.
    * A common interface for many different algorithms
    * Support for large-scale optimization.
    * Both global and local optimization algorithms.
    * Algorithms using function values only (derivative-free) and also
      algorithms exploiting user-supplied gradients.
    * Algorithms for unconstrained optimization, bound-constrained optimization,
      and general nonlinear inequality/equality constraints.
 .
 This package provides the HTML documentation for nlopt.

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = obj-$(shell dpkg-architecture  -q DEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DH_ALWAYS_EXCLUDE=__pycache__

PY3_DEFAULT = $(shell py3versions  -dv)
PY3_ALT = $(shell py3versions  -rv | sed "s/$(PY3_DEFAULT)//")

%:
	dh $@  --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -a -- -DNLOPT_FORTRAN=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$(PY3_DEFAULT) -DCMAKE_SKIP_INSTALL_RPATH=TRUE
	for py3alt in $(PY3_ALT); do dh_auto_configure -a --builddirectory=$(BUILDDIR)-python$${py3alt} -- -DNLOPT_FORTRAN=ON -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$${py3alt} -DCMAKE_SKIP_INSTALL_RPATH=TRUE; done
	dh_auto_configure -a --builddirectory=$(BUILDDIR)-c-only -- -DNLOPT_CXX=OFF -DNLOPT_PYTHON=OFF -DNLOPT_OCTAVE=OFF -DNLOPT_GUILE=OFF -DNLOPT_SWIG=OFF -DCMAKE_SKIP_INSTALL_RPATH=TRUE

override_dh_auto_build-arch:
	dh_auto_build
	for py3alt in $(PY3_ALT); do dh_auto_build --builddirectory=$(BUILDDIR)-python$${py3alt}; done
	dh_auto_build --builddirectory=$(BUILDDIR)-c-only

override_dh_auto_build-indep:
	mkdocs build

override_dh_auto_install-arch:
	dh_auto_install -a
	dh_auto_install -a --builddirectory=$(BUILDDIR)-c-only --destdir=debian/tmp-c-only
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc
	sed "s/-lnlopt/-lnlopt_cxx/" -i debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/nlopt_cxx.pc

override_dh_auto_install-indep:

override_dh_python3-arch:
	for py3alt in $(PY3_ALT); do \
		mkdir -p debian/python3-nlopt/usr/lib/python$${py3alt}/dist-packages/; \
		cp $(BUILDDIR)-python$${py3alt}/src/swig/_nlopt.so debian/python3-nlopt/usr/lib/python$${py3alt}/dist-packages/_nlopt.so; \
		chrpath -d debian/python3-nlopt/usr/lib/python$${py3alt}/dist-packages/_nlopt.so; \
	done
	dh_python3 -a

override_dh_auto_test-indep:
	echo No tests to run in arch-indep build.
	echo No tests to run in arch-indep build.

override_dh_strip:
	dh_strip
	find debian/octave-nlopt/usr/lib -name *.oct | \
		xargs strip --strip-unneeded --remove-section=.comment

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/python3/dist-packages

override_dh_shlibdeps:
	dh_shlibdeps
	dh_octave_substvar

override_dh_install-arch:
	dh_install
	# Remove C++ header from C interface
	find debian/libnlopt-dev -name nlopt.hpp -delete

override_dh_installdocs-indep:
	dh_installdocs -X js/jquery
	grep highlight.min.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*highlight.min.js\"|src=\"/usr/share/javascript/highlight.js/highlight.min.js\"|" -i
	grep js/jquery debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\".*js/jquery*.min.js|src=\"/usr/share/javascript/jquery/jquery.min.js|" -i
	grep -i mathjax.js debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|src=\"https://cdn.mathjax.org/mathjax/latest/MathJax.js|src=\"/usr/share/javascript/mathjax/MathJax.js|" -i
	grep github.min.css debian/nlopt-doc/usr/share/doc/nlopt-doc/site/* -R -ls | xargs -r sed "s|href=\".*github.min.css\"|src=\"/usr/share/javascript/highlight.js/styles/github.css\"|" -i

override_dh_link-arch:
	for package in libnlopt-dev libnlopt-guile0 octave-nlopt python3-nlopt; do \
		rm -rf debian/$$package/usr/share/doc/$$package; \
	done
	dh_link

=== debian/tests/control ===
Tests: test-nlopt
Depends: @,
  gcc,
  gfortran,
  guile-2.2,
  octave,
  pkg-config,
  python3,
  python3-numpy
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%nlopt-$1.tar.gz%" \
 https://github.com/stevengj/nlopt/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
